from sys import argv
from csv import reader

def main():
    if len(argv) != 2:
        return

    sounds_dict = {}

    with open(argv[1]) as csv_file:
        raeder = reader(csv_file)

        for row in raeder:

            sound = row[0][-1]
            try:
                sounds_dict[sound].append(row)
            except KeyError:
                sounds_dict[sound] = []
                sounds_dict[sound].append(row)

    print("var ROMAJI_ = map[string][]RomajiCharacter{")

    for sound in sounds_dict:
        print(f"\t\"{sound}\": []RomajiCharacter{{")
        for character in sounds_dict[sound]:
            print(f"\t\tRomajiCharacter{{")
            print(f"\t\t\t\"{character[1]}\",")
            print(f"\t\t\t\"{sound}\",")
            print(f"\t\t\ttrue,")
            print(f"\t\t\t[]string{{\"{character[0]}\"}},")
            print("\t\t},")
        print("\t},")
    print("}")


main()
